function ADEI(maindiv_id, sidebar_id, statusbar_id, menu_id, session_id) {
    this.maindiv_node = document.getElementById(maindiv_id);
    this.sidebar_node = document.getElementById(sidebar_id);
    this.statusbar_node = document.getElementById(statusbar_id);
    
    if ((!this.sidebar_node)||(!this.statusbar_node)||(!this.maindiv_node)) {
	alert("ADEI INTERNAL ERROR: Some of importnant HTML elements are not found");
    }

    this.config = new CONFIG;
    this.module = new MODULE(null, configSetupModule, this.config);
    this.popup = new POPUP(Geometry, null);

    this.updater = new UPDATER(this.config, this.module, this.popup);

    if (menu_id) this.menu = new MENU(this.config, this.updater, menu_id);
    else this.menu = null;
    
    this.source = null;
    this.source_interval = null;
    this.source_window = null;
    
    this.data_export = null;
    this.graph = null;
    
    this.options = null;
    
    this.cfg = new Object({
	'window_border': 10,
	'parse_delay': 100,
	'subsecond_threshold': 0,
	'zoom_ratio': 2,
	'query': null
    });
    
    if (typeof session_id == "undefined")
	this.adei_session = Math.floor(Math.random() * 4294967295);
    else
	this.adei_session = session_id;

    this.AddToQuery('adei_session=' + session_id);
    
	// Tracking key presses and currently pressed key    
    this.key = false;
    
    document.onkeydown = this.keyDown(this);
    document.onkeyup = this.keyUp(this);
    document.onkeypress = this.keyPress(this);
}

ADEI.prototype.keyDown = function (self) {
    return function(ev) {
	var keyID = (window.event) ? event.keyCode : ev.keyCode;
	self.key = keyID;
    }
}

ADEI.prototype.keyUp = function (self) {
    return function(ev) {
//	var keyID = (window.event) ? event.keyCode : ev.keyCode;
	self.key = false;
    }
}

ADEI.prototype.keyPress = function (self) {
    return function(ev) {
	var keyID = (window.event) ? event.keyCode : ev.keyCode;
	if (keyID == 0) keyID = ev.charCode;
	
//	alert(keyID);
//	alert(ev.charCode);
    }
}

ADEI.prototype.SetOptions = function(opts) {
    this.options = opts;
}

ADEI.prototype.SetProperty = function(name, val) {
    this.cfg[name] = val;
}

ADEI.prototype.AddToQuery = function(props) {
    if (this.cfg['query']) this.cfg['query'] += '&' + props;
    else this.cfg['query'] = props;
}

ADEI.prototype.RegisterModule = function(mod, mod_class) {
    this.module.Register(mod, mod_class);
}

ADEI.prototype.RegisterSuperPopup = function(popup, geometry_node) {
    if (this.popup) {
	this.popup.TryFixedSizeMode(this.sidebar_node, popup, geometry_node);
    }
}

ADEI.prototype.AttachSourceModule = function(source, ivl, wnd) {
    this.source = source;
    this.source_interval = ivl;
    this.source_window = wnd;

    source.AttachConfig(this.config);
    source.Init(this.updater, this.options);

    if (this.menu) this.menu.AttachWindow(wnd);
}

ADEI.prototype.AttachExportModule = function(data_export) {
    this.data_export = data_export;

    data_export.AttachConfig(this.config);    
    data_export.Init();
    
    if (this.menu) this.menu.AttachExporter(data_export);
}

ADEI.prototype.AttachGraphModule = function(graph) {
    this.graph = graph;

    graph.AttachConfig(this.config);    
    graph.AttachWindow(this.source_window);
    graph.AttachSource(this.source);
    graph.AttachExporter(this.data_export);
}

ADEI.prototype.Start = function(mod, update_rate) {
    this.module.Open(mod);
    this.menu.Load();
    this.updater.Start(update_rate);
}

ADEI.prototype.OpenModule = function(mod) {
    this.module.Open(mod);
}

ADEI.prototype.SwitchPopup = function(mod) {
    this.popup.Switch(mod);
}

ADEI.prototype.UpdateModuleGeometry = function(mod, width, height) {
    var m = this.module.GetModule(mod);
    if (!m) return;

    var mboffset = domGetNodeOffset(this.maindiv_node);
/*
    This was a rougher approach
    var h1 = height - 
	document.getElementById("header_div").offsetHeight - 
	this.statusbar_node.offsetHeight;
    var w1 = width - this.sidebar_node.offsetWidth;
*/
    
    var h = this.statusbar_node.offsetTop - mboffset[1]; /* substract something to fix IE6 */
    var w = width - mboffset[0]; 

    if (typeof m.AdjustGeometry != "undefined")
        m.AdjustGeometry(w, h, width, this.statusbar_node.offsetTop);

    this.popup.UpdateGlobalGeometry(h, this.statusbar_node.offsetTop);
}

ADEI.prototype.GetURL = function(page, props) {
    if (this.cfg.query) {
	if (props) return page + "?" + this.cfg.query + "&" + props;
	return page + "?" + this.cfg.query;
    } else {
	if (props) return page + "?" + props;
	return page;
    }
}

ADEI.prototype.GetServiceURL = function(name, props) {
    return this.GetURL("services/" + name + ".php", props);
}

ADEI.prototype.GetService = function(name, props) {
    return this.GetServiceURL(name, props);
}

